/* lab4b.c */

#include <stdlib.h>
#include <stdio.h>
#include <pthread.h>
#include <math.h>

#define I_MAX_THREADS   8
#define I_INF           30000
#define SZ_ENT_BAR      "%d: entrei na barreira\n"
#define SZ_SAI_BAR      "%d: Sai da barreira\n"
#define SZ_CALCULANDO   "%d: Calculando nova linha\n"
#define SZ_COPIANDO     "%d: Copiando nova linha\n" 
#define SZ_ERRO_CRIA    "Erro na criacao do thread %d\n"
#define SZ_ERRO_JUNTA   "Erro ao juntar o thread %d\n"
#define SZ_NUM_THREADS  "Numero de threads %d\n"
#define SZ_INF          "\tINF"

int Chegou[ I_MAX_THREADS ]                                                    ,
    Matriz[ I_MAX_THREADS ][ I_MAX_THREADS ]
             = { {     0,     3, I_INF,     1, I_INF, I_INF, I_INF, I_INF } ,
                 {     3,     0, I_INF,     1,     4, I_INF, I_INF, I_INF } ,
                 { I_INF, I_INF,     0,     5,     1, I_INF, I_INF, I_INF } ,
                 {     1,     1,     5,     0,     2, I_INF, I_INF, I_INF } ,
                 { I_INF,     4,     1,     2,     0, I_INF, I_INF, I_INF } ,
                 { I_INF, I_INF, I_INF, I_INF, I_INF, I_INF, I_INF, I_INF } ,
                 { I_INF, I_INF, I_INF, I_INF, I_INF, I_INF, I_INF, I_INF } ,
                 { I_INF, I_INF, I_INF, I_INF, I_INF, I_INF, I_INF, I_INF }  } ,
    MatrizAux[ I_MAX_THREADS ][ I_MAX_THREADS ]                                ;


void Barreira( int iMeuId ) ;

int iSomarInt( int iNumero1 ,
               int iNumero2  ) ;

void* CalcularCam( void* MeuId ) ;

void ImprimirMat( void ) ;


void Barreira( int iMeuId ) {
   double dMaxEst  = log( I_MAX_THREADS ) / log( 2 ) ;
   int    iMaxEst  = ( int )dMaxEst                  ,
          iEstagio = 0                               ,
          iDesloc                                    ,
          iVizinho                                   ;

   printf( SZ_ENT_BAR, iMeuId ) ;  /* entra na barreira */

   for ( iEstagio = 0 ; iEstagio < iMaxEst ; iEstagio++ ) {
      Chegou[ iMeuId ]++ ;

   /* determina o vizinho para o estagio atual */
      iDesloc = pow( 2, iEstagio ) ;
      if ( ( ( iMeuId / iDesloc ) % 2 ) == 0 ) {
         iVizinho = iMeuId + iDesloc ;
      } else {
         iVizinho = iMeuId - iDesloc ;
      } /* if */

      while ( Chegou[ iVizinho ] < Chegou[ iMeuId ] ) { }
   } /* for */

   printf( SZ_SAI_BAR, iMeuId ) ;  /* sai da barreira */
} /* Barreira */


int iSomarInt( int iNumero1 ,
               int iNumero2  ) {

   if ( iNumero1 == I_INF
     || iNumero2 == I_INF ) {
      return I_INF ;
   } /* if */

   return iNumero1 + iNumero2 ; /* supondo que a soma no da' overflow */

} /* iSomarInt */


void* CalcularCam( void* MeuId ) {
   double dMaxIte = log( I_MAX_THREADS ) / log( 2 ) ;
   int    iMaxIte = ( int )dMaxIte                  ,
          iMeuId = *( int* )MeuId                   ,  
          i                                         ,
          j                                         ,
          k                                         ;

   for ( k = 0 ; k < iMaxIte ; k++ ) {
      printf( SZ_CALCULANDO, iMeuId ) ;
 
      for ( i = 0 ; i < I_MAX_THREADS ; i++ ) {
         MatrizAux[ iMeuId ][ i ] = I_INF ;

         for ( j = 0 ; j < I_MAX_THREADS ; j++ ) {
            int iResultado
                        = iSomarInt( Matriz[ iMeuId ][ j ], Matriz[ j ][ i ] ) ;
            
            MatrizAux[ iMeuId ][ i ]
                        = ( iResultado < MatrizAux[ iMeuId ][ i ] ) ?
                            iResultado : MatrizAux[ iMeuId ][ i ] ; 
         } /* for */

         j = 0 ;
         do {
            j++ ;
         } while ( j < 100000 * iMeuId ) ;
      } /* for */

      Barreira( iMeuId ) ;

      printf( SZ_COPIANDO, iMeuId ) ;
      for ( i = 0 ; i < I_MAX_THREADS ; i++ ) {

      /* copia a linha do vizinho */
         Matriz[ ( iMeuId + 1 ) % I_MAX_THREADS ][ i ] 
               = MatrizAux[ ( iMeuId + 1 ) % I_MAX_THREADS ][ i ] ;
          
         j = 0 ;
         do {
            j++ ;
         } while ( j < 100000 * iMeuId ) ; 

      } /* for */

      Barreira( iMeuId ) ;
      
   } /* for */

   return NULL ;

} /* CalcularCam */


void ImprimirMat( void ) {
   int i ,
       j ;
   
   for ( i = 0 ; i < I_MAX_THREADS ; i++ ) {

      for ( j = 0 ; j < I_MAX_THREADS ; j++ ) {
         if ( Matriz[ i ][ j ] == I_INF ) {
            printf( SZ_INF ) ;
         } else {
            printf( "\t%d", Matriz[ i ][ j ] ) ;
         } /* if */
      } /* for */

      printf( "\n" ) ;
   } /* for */
} /* ImprimirMat */


int main( void ) {
   int       iErro                   ,
             i                       ;
   int*      pMeuId                  ;
   pthread_t Thread[ I_MAX_THREADS ] ;

   printf( SZ_NUM_THREADS, I_MAX_THREADS ) ;

   for ( i = 0 ; i < I_MAX_THREADS ; i++ ) {
      Chegou[ i ] = 0 ;
   } /* for */

   for ( i = 0 ; i < I_MAX_THREADS ; i++ ) {
      pMeuId = ( int* )malloc( sizeof( int ) ) ;
      *pMeuId = i ;
      iErro = pthread_create( &Thread[ i ], NULL, CalcularCam,
                                                  ( void* )( pMeuId ) ) ;

      if ( iErro != 0 ) {
         printf( SZ_ERRO_CRIA, i ) ;
         return 1 ;
      } /* if */
   } /* for */

   for ( i = 0 ; i < I_MAX_THREADS ; i++ ) {
      void** Retorno ;
      
      iErro = pthread_join( Thread[ i ], Retorno ) ;
      if ( iErro != 0 ) {
         printf( SZ_ERRO_JUNTA, i ) ;
         return 1 ;
      } /* if */ 
   } /* for */

   ImprimirMat( ) ;
   return 0 ;
}
