/* lab4c.c */

#include <stdlib.h>
#include <stdio.h>
#include <pthread.h>
#include <math.h>

#define I_MAX_THREADS   8
#define SZ_ENT_BAR      "%d: entrei na barreira\n"
#define SZ_SAI_BAR      "%d: Sai da barreira\n"
#define SZ_ORDENANDO    "%d: Ordenando o vetor\n"
#define SZ_ERRO_CRIA    "Erro na criacao do thread %d\n"
#define SZ_ERRO_JUNTA   "Erro ao juntar o thread %d\n"
#define SZ_NUM_THREADS  "Numero de threads %d\n"

int Chegou[ I_MAX_THREADS ]                              ,
    Vetor[ I_MAX_THREADS ]  = { 7, 6, 5, 4, 3, 2, 1, 0 } ;


void Barreira( int iMeuId ) ;

void* OrdernarVetor( void* MeuId ) ;

void ImprimirVetor( void ) ;


void Barreira( int iMeuId ) {
   double dMaxEst  = log( I_MAX_THREADS ) / log( 2 ) ;
   int    iMaxEst  = ( int )dMaxEst                  ,
          iEstagio = 0                               ,
          iDesloc                                    ,
          iVizinho                                   ;

   printf( SZ_ENT_BAR, iMeuId ) ;  /* entra na barreira */

   for ( iEstagio = 0 ; iEstagio < iMaxEst ; iEstagio++ ) {
      Chegou[ iMeuId ]++ ;

   /* determina o vizinho para o estagio atual */
      iDesloc = pow( 2, iEstagio ) ;
      if ( ( ( iMeuId / iDesloc ) % 2 ) == 0 ) {
         iVizinho = iMeuId + iDesloc ;
      } else {
         iVizinho = iMeuId - iDesloc ;
      } /* if */

      while ( Chegou[ iVizinho ] < Chegou[ iMeuId ] ) { }
   } /* for */

   printf( SZ_SAI_BAR, iMeuId ) ;  /* sai da barreira */
} /* Barreira */


void* OrdernarVetor( void* MeuId ) {
   int i                       ,
       iMeuId = *( int* )MeuId ;

   for ( i = 0 ; i < I_MAX_THREADS ; i++ ) {

      if ( ( i % 2 ) == ( iMeuId % 2 )
        && iMeuId != I_MAX_THREADS - 1
        && Vetor[ iMeuId + 1 ] < Vetor[ iMeuId ] ) {

         int iTemp = Vetor[ iMeuId ] ;
         Vetor[ iMeuId ] = Vetor[ iMeuId + 1 ] ;
         Vetor[ iMeuId + 1 ] = iTemp ;

         printf( SZ_ORDENANDO, iMeuId ) ;

      } /* if */

      Barreira( iMeuId ) ;

   } /* for */

   return NULL ;
} /* OrdernarVetor */


void ImprimirVetor( void ) {
   int i ;

   for ( i = 0 ; i < I_MAX_THREADS ; i++ ) {
      printf( "%d ", Vetor[ i ] ) ;
   } /* for */

   printf( "\n" ) ;
} /* ImprimirVetor */


int main( void ) {
   int       iErro                   ,
             i                       ;
   int*      pMeuId                  ;
   pthread_t Thread[ I_MAX_THREADS ] ;

   printf( SZ_NUM_THREADS, I_MAX_THREADS ) ;

   for ( i = 0 ; i < I_MAX_THREADS ; i++ ) {
      Chegou[ i ] = 0 ;
   } /* for */

   for ( i = 0 ; i < I_MAX_THREADS ; i++ ) {
      pMeuId = ( int* )malloc( sizeof( int ) ) ;
      *pMeuId = i ;
      iErro = pthread_create( &Thread[ i ], NULL, OrdernarVetor,
                                                  ( void* )( pMeuId ) ) ;

      if ( iErro != 0 ) {
         printf( SZ_ERRO_CRIA, i ) ;
         return 1 ;
      } /* if */
   } /* for */

   for ( i = 0 ; i < I_MAX_THREADS ; i++ ) {
      void** Retorno ;
      
      iErro = pthread_join( Thread[ i ], Retorno ) ;
      if ( iErro != 0 ) {
         printf( SZ_ERRO_JUNTA, i ) ;
         return 1 ;
      } /* if */ 
   } /* for */

   ImprimirVetor( ) ;
   return 0 ;
}
